package prt2.age.file;

import android.content.Context;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.OptionalDataException;
import java.io.StreamCorruptedException;
import prt2.age.graph.LocatedGraph;

/**
 *
 * @author trust56
 */
public class FileHandler {

    private FileHandler() {
    }

    public static FileHandler getInstance() {
        return FileHandlerHolder.INSTANCE;
    }

    public <T> LocatedGraph<T> load() throws StreamCorruptedException, IOException, OptionalDataException, ClassNotFoundException {
        FileInputStream is;
        try {
            is = context.openFileInput(filename);
        } catch (FileNotFoundException ex) {
            return null;
        }
        ObjectInputStream ois = new ObjectInputStream(is);
        LocatedGraph<T> graph = (LocatedGraph<T>) ois.readObject();
        ois.close();
        return graph;
    }

    public void save(LocatedGraph<Character> graph) throws FileNotFoundException, IOException {
        FileOutputStream os = context.openFileOutput(filename, Context.MODE_PRIVATE);
        ObjectOutputStream oos = new ObjectOutputStream(os);
        oos.writeObject(graph);
        oos.close();
    }

    private static class FileHandlerHolder {

        private static final FileHandler INSTANCE = new FileHandler();
    }
    private final String filename = "graph";
    private Context context;

    public void setContext(Context context) {
        this.context = context;
    }
}
